var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import * as OracleServer from './index';
import { deleteTests } from './test/delete-tests';
import { announcementTests } from './test/announcement-tests';
import { noinputTests } from './test/noinput-tests';
console.debug('tests.ts');
OracleServer.ConfigureServerURL('http://localhost:9998/');
OracleServer.ConfigureAuthorizationHeader('Basic ' + Buffer.from('bitcoins:password').toString('base64'));
export function runTests() {
    return __awaiter(this, void 0, void 0, function* () {
        yield deleteTests();
        yield announcementTests();
        yield noinputTests();
    });
}
runTests();
//# sourceMappingURL=tests.js.map